###################################################
### chunk number 1:  eval=FALSE
###################################################
## install.packages("BoolNet")


###################################################
### chunk number 2: 
###################################################
library(BoolNet)


###################################################
### chunk number 3: 
###################################################
cellcycle <- loadNetwork("cellcycle.txt")


###################################################
### chunk number 4: 
###################################################
data(cellcycle)


###################################################
### chunk number 5: 
###################################################
data(yeastTimeSeries)


###################################################
### chunk number 6: 
###################################################
binSeries <- binarizeTimeSeries(yeastTimeSeries)


###################################################
### chunk number 7: 
###################################################
net <- reconstructNetwork(binSeries$binarizedMeasurements, 
method="bestfit", maxK=4)


###################################################
### chunk number 8: 
###################################################
net


###################################################
### chunk number 9: 
###################################################
plotNetworkWiring(net)


###################################################
### chunk number 10: 
###################################################
singleNet <- chooseNetwork(net, c(1,2,3,2))


###################################################
### chunk number 11: 
###################################################
singleNet


###################################################
### chunk number 12: 
###################################################
net <- generateRandomNKNetwork(n=10, k=3)


###################################################
### chunk number 13: 
###################################################
net <- generateRandomNKNetwork(n=10, k=c(1,2,3,1,3,2,3,2,1,1))


###################################################
### chunk number 14: 
###################################################
net <- generateRandomNKNetwork(n=20, k=20, topology="scale_free")


###################################################
### chunk number 15: 
###################################################
net <- generateRandomNKNetwork(n=10, k=3, linkage="lattice")


###################################################
### chunk number 16: 
###################################################
net <- generateRandomNKNetwork(n=10, k=3, 
functionGeneration="biased", zeroBias=0.75)


###################################################
### chunk number 17: 
###################################################
data(cellcycle)
knockedOut <- fixGenes(cellcycle, "cycd", 0)


###################################################
### chunk number 18: 
###################################################
knockedOut <- fixGenes(cellcycle, 1, 0)


###################################################
### chunk number 19: 
###################################################
overExpressed <- fixGenes(cellcycle, "cycd", 1)


###################################################
### chunk number 20: 
###################################################
originalNet <- fixGenes(knockedOut, "cycd", -1)


###################################################
### chunk number 21: 
###################################################
newNet <- fixGenes(cellcycle, c("cycd","cyce"), c(0,1))


###################################################
### chunk number 22: 
###################################################
data(cellcycle)
stateTransition(cellcycle, rep(1,10))


###################################################
### chunk number 23:  eval=FALSE
###################################################
## stateTransition(cellcycle, rep(1,10), type="asynchronous")


###################################################
### chunk number 24:  eval=FALSE
###################################################
## stateTransition(cellcycle, rep(1,10), type="asynchronous", 
## geneProbabilities=c(0.05,0.05,0.2,0.3,0.05,0.05,0.05,0.05,0.1,0.1))


###################################################
### chunk number 25: 
###################################################
stateTransition(cellcycle, rep(1,10), type="asynchronous", 
chosenGene="cyce")


###################################################
### chunk number 26: 
###################################################
data(examplePBN)


###################################################
### chunk number 27:  eval=FALSE
###################################################
## data(examplePBN)
## stateTransition(examplePBN, c(0,1,1), type="probabilistic")


###################################################
### chunk number 28: 
###################################################
stateTransition(examplePBN, c(0,1,1), type="probabilistic", 
chosenFunctions=c(2,1,2))


###################################################
### chunk number 29: 
###################################################
attr <- getAttractors(cellcycle)


###################################################
### chunk number 30:  eval=FALSE
###################################################
## data(cellcycle)
## attr <- getAttractors(cellcycle)
## attr


###################################################
### chunk number 31:  eval=FALSE
###################################################
## print(attr, activeOnly=TRUE)


###################################################
### chunk number 32:  eval=FALSE
###################################################
## tt <- getTransitionTable(attr)
## tt


###################################################
### chunk number 33:  eval=FALSE
###################################################
## getBasinOfAttraction(attr, 1)


###################################################
### chunk number 34:  eval=FALSE
###################################################
## getStateSummary(attr, c(1,1,1,1,1,1,1,1,1,1))


###################################################
### chunk number 35: 
###################################################
plotStateGraph(attr)


###################################################
### chunk number 36:  eval=FALSE
###################################################
## attr <- getAttractors(cellcycle, method="chosen", 
## startStates=list(rep(0,10),rep(1,10)))


###################################################
### chunk number 37:  eval=FALSE
###################################################
## attr <- getAttractors(cellcycle, method="random", startStates=100)


###################################################
### chunk number 38:  eval=FALSE
###################################################
## plotAttractors(attr,subset=2)


###################################################
### chunk number 39:  eval=FALSE
###################################################
## attractorsToLaTeX(attr,subset=2,file="attractors.tex")


###################################################
### chunk number 40:  eval=FALSE
###################################################
## attr <- getAttractors(cellcycle, type="asynchronous",
## method="random", startStates=500)


###################################################
### chunk number 41:  eval=FALSE
###################################################
## attr


###################################################
### chunk number 42:  eval=FALSE
###################################################
## attr <- getAttractors(cellcycle, type="asynchronous",
## method="random", startStates=500, avoidSelfLoops=FALSE)


###################################################
### chunk number 43:  eval=FALSE
###################################################
## plotAttractors(attr,subset=2,mode="graph",drawLabels=FALSE)


###################################################
### chunk number 44: 
###################################################
data(examplePBN)
sim <- markovSimulation(examplePBN)
sim


###################################################
### chunk number 45: 
###################################################
plotPBNTransitions(sim)


###################################################
### chunk number 46: 
###################################################
data(cellcycle)
sim <- markovSimulation(cellcycle, numIterations=1024, 
returnTable=FALSE)
sim


###################################################
### chunk number 47: 
###################################################
sim <- markovSimulation(cellcycle, numIterations=1024,
returnTable=FALSE, startStates=list(rep(1,10)))
sim


###################################################
### chunk number 48: 
###################################################
data(cellcycle)
perturbedNet <- perturbNetwork(cellcycle, perturb="functions", 
method="bitflip")


###################################################
### chunk number 49: 
###################################################
perturbedNet <- perturbNetwork(cellcycle, perturb="functions", 
method="shuffle")


###################################################
### chunk number 50: 
###################################################
perturbedNet <- perturbNetwork(cellcycle, perturb="states", 
method="bitflip", numStates=10)


###################################################
### chunk number 51:  eval=FALSE
###################################################
## # Perform a robustness test on a network
## # by counting the numbers of perturbed networks
## # containing the attractors of the original net
## 
## library(BoolNet)
## 
## # load mammalian cell cycle network
## data(cellcycle)
## 
## # get attractors in original network
## attrs <- getAttractors(cellcycle, canonical=TRUE)
## 
## # create 1000 perturbed copies of the network and search for attractors
## perturbationResults <- sapply(1:1000,function(i)
## {
##   # perturb network and identify attractors
##   perturbedNet <- perturbNetwork(cellcycle, perturb="functions", method="bitflip")
##   perturbedAttrs <- getAttractors(perturbedNet, canonical=TRUE)
##   
##   # check whether the attractors in the original network exist in the perturbed network
##   attractorIndices <- sapply(attrs$attractors,function(attractor1)
##         {
##           index <- which(sapply(perturbedAttrs$attractors,function(attractor2)
##             {
##               identical(attractor1,attractor2)
##             }))
##           if (length(index) == 0)
##             NA
##           else
##             index
##         })
##   return(attractorIndices)
## })
## 
## # perturbationResults now contains a matrix
## # with the first 2 columns specifying the indices or the 
## # original attractors in the perturbed network 
## # (or NA if the attractor was not found) and the next 2 
## # columns counting the numbers of states
## # in the basin of attraction (or NA if the attractor was not found)
## 
## # measure the total numbers of occurrences of the original attractors in the perturbed copies
## numOccurrences <- apply(perturbationResults[1:length(attrs$attractors),,drop=FALSE], 1,
##                       function(row)sum(!is.na(row)))
## 
## # print original attractors
## cat("Attractors in original network:\n")
## print(attrs)
## 
## # print information
## cat("Number of occurrences of the original attractors",
## 	"in 1000 perturbed copies of the network:\n")
## for (i in 1:length(attrs$attractors))
## {
##   cat("Attractor ",i,": ",numOccurrences[i],"\n",sep="")
## }


###################################################
### chunk number 52:  eval=FALSE
###################################################
## data(cellcycle)
## testNetworkProperties(cellcycle, numRandomNets=100, 
## testFunction="testAttractorRobustness", 
## testFunctionParams = list(copies=100))


###################################################
### chunk number 53:  eval=FALSE
###################################################
## testNetworkProperties(cellcycle, numRandomNets=100, 
## testFunction="testIndegree")


###################################################
### chunk number 54:  eval=FALSE
###################################################
## testNetworkProperties(cellcycle, numRandomNets=100, 
## testFunction="testIndegree", accumulation="kullback_leibler")


###################################################
### chunk number 55: 
###################################################
testBasinSizes <- function(network, accumulate=TRUE, params)
{
  attr <- getAttractors(network)
  basinSizes <- sapply(attr$attractors, function(a)
                      { 
                         a$basinSize
                      })
   if (accumulate)
     return(mean(basinSizes))
   else
     return(basinSizes)                  
}


###################################################
### chunk number 56:  eval=FALSE
###################################################
## testNetworkProperties(cellcycle, numRandomNets=1000,
## testFunction="testBasinSizes",
## xlab="Average size of basins of attraction")


###################################################
### chunk number 57:  eval=FALSE
###################################################
## system.file("doc/example.btp", package="BoolNet")


###################################################
### chunk number 58: 
###################################################
net <- loadBioTapestry("example.btp")


###################################################
### chunk number 59:  eval=FALSE
###################################################
## net


###################################################
### chunk number 60:  eval=FALSE
###################################################
## plotNetworkWiring(net)


###################################################
### chunk number 61:  eval=FALSE
###################################################
## data(cellcycle)
## attr <- getAttractors(cellcycle)
## toPajek(attr, file="cellcycle.net")


###################################################
### chunk number 62:  eval=FALSE
###################################################
## toPajek(attr, file="cellcycle.net", includeLabels=TRUE)


